---
image: docker.io/eqsoft4/dockerx:${DOCKER_IMAGE_VERSION}
services:
  - name: docker.io/library/docker:${DOCKER_IMAGE_VERSION}-dind
    alias: docker

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: never
    - if: $CI_PIPELINE_SOURCE == "schedule"
    #- if: $CI_PIPELINE_SOURCE == "web"
    #- if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_REF_NAME == "latest"
    #- if: $CI_COMMIT_TAG

stages:
  - check
  - build
  - test
  - deploy

.prepare:
  cache:
    - key: cache-$CI_PIPELINE_ID
      paths:
        - cache/
  variables:
    AUTOBUILDERX_REF: "main"
  before_script:
    - |
      curl -L -s "https://gitlab.com/eqsoft-appstack/autobuilderx/-/archive/${AUTOBUILDERX_REF}/autobuilderx-${AUTOBUILDERX_REF}.tar.gz" | tar xzf - --strip-components=1 "autobuilderx-${AUTOBUILDERX_REF}/bin"
      chmod -R 755 bin
      export PATH=$PATH:$(pwd)/bin
  resource_group: buildx

check:
  stage: check
  script: "autobuilderx -s check"
  extends: .prepare

build:
  stage: build
  script: "autobuilderx -s build"
  extends: .prepare

test:
  stage: test
  script: "autobuilderx -s test"
  extends: .prepare

deploy:
  stage: deploy
  script: "autobuilderx -s deploy"
  extends: .prepare
